m=Map("radvd",translate("Radvd"),
translate("Radvd is a router advertisement daemon for IPv6. "..
"It listens to router solicitations and sends router advertisements "..
"as described in RFC 4861."))
local i=require"luci.model.network".init(m.uci)
local n=require"luci.util"
s=m:section(TypedSection,"interface",translate("Interfaces"))
s.template="cbi/tblsection"
s.extedit=luci.dispatcher.build_url("admin/network/radvd/interface/%s")
s.anonymous=true
s.addremove=true
function s.create(...)
local e=TypedSection.create(...)
luci.http.redirect(s.extedit%e)
end
function s.remove(a,t)
if m.uci:get("radvd",t)=="interface"then
local e=m.uci:get("radvd",t,"interface")
if e then
m.uci:delete_all("radvd","prefix",
function(t)return t.interface==e end)
m.uci:delete_all("radvd","route",
function(t)return t.interface==e end)
m.uci:delete_all("radvd","rdnss",
function(t)return t.interface==e end)
end
end
return TypedSection.remove(a,t)
end
o=s:option(Flag,"ignore",translate("Enable"))
o.rmempty=false
o.width="30px"
function o.cfgvalue(...)
local e=Flag.cfgvalue(...)
return e=="1"and"0"or"1"
end
function o.write(a,t,e)
Flag.write(a,t,e=="1"and"0"or"1")
end
o=s:option(DummyValue,"interface",translate("Interface"))
o.template="cbi/network_netinfo"
o.width="10%"
o=s:option(DummyValue,"UnicastOnly",translate("Multicast"))
function o.cfgvalue(t,e)
local t=Value.cfgvalue(t,e)
local e=m.uci:get("radvd",e,"client")
return(t=="1"or(e and#e>0))and translate("no")or translate("yes")
end
o=s:option(DummyValue,"AdvSendAdvert",translate("Advertising"))
function o.cfgvalue(...)
local e=Value.cfgvalue(...)
return e=="1"and translate("yes")or translate("no")
end
o=s:option(DummyValue,"MaxRtrAdvInterval",translate("Max. interval"))
function o.cfgvalue(...)
local e=Value.cfgvalue(...)or"600"
return e.."s"
end
o=s:option(DummyValue,"AdvHomeAgentFlag",translate("Mobile IPv6"))
function o.cfgvalue(...)
local e=Value.cfgvalue(...)
return e=="1"and translate("yes")or translate("no")
end
o=s:option(DummyValue,"AdvDefaultPreference",translate("Preference"))
function o.cfgvalue(...)
local e=Value.cfgvalue(...)or"medium"
return translate(e)
end
s2=m:section(TypedSection,"prefix",translate("Prefixes"))
s2.template="cbi/tblsection"
s2.extedit=luci.dispatcher.build_url("admin/network/radvd/prefix/%s")
s2.addremove=true
s2.anonymous=true
function s2.create(...)
local e=TypedSection.create(...)
luci.http.redirect(s2.extedit%e)
end
o=s2:option(Flag,"ignore",translate("Enable"))
o.rmempty=false
o.width="30px"
function o.cfgvalue(...)
local e=Flag.cfgvalue(...)
return e=="1"and"0"or"1"
end
function o.write(t,e,a)
Flag.write(t,e,a=="1"and"0"or"1")
end
o=s2:option(DummyValue,"interface",translate("Interface"))
o.template="cbi/network_netinfo"
o.width="10%"
pfx=s2:option(DummyValue,"prefix",translate("Prefix"))
pfx.width="60%"
function pfx.cfgvalue(e,a)
local e=m.uci:get_list("radvd",a,e.option)
local t={}
if not e or#e==0 or(#e==1 and#e[1]==0)then
local t=i:get_network(m.uci:get("radvd",a,"interface"))
if t then
local t=i:get_interface(t:ifname())
if t then
local a
for a,t in ipairs(t:ip6addrs())do
if not t:is6linklocal()then
e=t:string()
break
end
end
end
end
end
for e in n.imatch(e)do
e=luci.ip.IPv6(e)
if e then
t[#t+1]=e:string()
end
end
if#t==0 then
t[1]="?"
end
return table.concat(t,", ")
end
o=s2:option(DummyValue,"AdvAutonomous",translate("Autonomous"))
function o.cfgvalue(...)
local e=Value.cfgvalue(...)
return e=="1"and translate("yes")or translate("no")
end
o=s2:option(DummyValue,"AdvOnLink",translate("On-link"))
function o.cfgvalue(...)
local e=Value.cfgvalue(...)
return e=="1"and translate("yes")or translate("no")
end
o=s2:option(DummyValue,"AdvValidLifetime",translate("Validity time"))
function o.cfgvalue(...)
local e=Value.cfgvalue(...)or"86400"
return translate(e)
end
s3=m:section(TypedSection,"route",translate("Routes"))
s3.template="cbi/tblsection"
s3.extedit=luci.dispatcher.build_url("admin/network/radvd/route/%s")
s3.addremove=true
s3.anonymous=true
function s3.create(...)
local e=TypedSection.create(...)
luci.http.redirect(s3.extedit%e)
end
o=s3:option(Flag,"ignore",translate("Enable"))
o.rmempty=false
o.width="30px"
function o.cfgvalue(...)
local e=Flag.cfgvalue(...)
return e=="1"and"0"or"1"
end
function o.write(a,t,e)
Flag.write(a,t,e=="1"and"0"or"1")
end
o=s3:option(DummyValue,"interface",translate("Interface"))
o.template="cbi/network_netinfo"
o.width="10%"
o=s3:option(DummyValue,"prefix",translate("Prefix"))
o.width="60%"
o.cfgvalue=pfx.cfgvalue
o=s3:option(DummyValue,"AdvRouteLifetime",translate("Lifetime"))
function o.cfgvalue(e,t)
local e=Value.cfgvalue(e,t)or"1800"
return translate(e)
end
o=s3:option(DummyValue,"AdvRoutePreference",translate("Preference"))
function o.cfgvalue(t,e)
local e=Value.cfgvalue(t,e)or"medium"
return translate(e)
end
s4=m:section(TypedSection,"rdnss",translate("RDNSS"))
s4.template="cbi/tblsection"
s4.extedit=luci.dispatcher.build_url("admin/network/radvd/rdnss/%s")
s4.addremove=true
s4.anonymous=true
function s4.create(...)
local e=TypedSection.create(...)
luci.http.redirect(s4.extedit%e)
end
o=s4:option(Flag,"ignore",translate("Enable"))
o.rmempty=false
o.width="30px"
function o.cfgvalue(...)
local e=Flag.cfgvalue(...)
return e=="1"and"0"or"1"
end
function o.write(e,t,a)
Flag.write(e,t,a=="1"and"0"or"1")
end
o=s4:option(DummyValue,"interface",translate("Interface"))
o.template="cbi/network_netinfo"
o.width="10%"
o=s4:option(DummyValue,"addr",translate("Address"))
o.width="60%"
o.cfgvalue=pfx.cfgvalue
o=s4:option(DummyValue,"AdvRDNSSLifetime",translate("Lifetime"))
function o.cfgvalue(e,t)
local e=Value.cfgvalue(e,t)or"1200"
return translate(e)
end
s5=m:section(TypedSection,"dnssl",translate("DNSSL"))
s5.template="cbi/tblsection"
s5.extedit=luci.dispatcher.build_url("admin/network/radvd/dnssl/%s")
s5.addremove=true
s5.anonymous=true
function s5.create(...)
local e=TypedSection.create(...)
luci.http.redirect(s5.extedit%e)
end
o=s5:option(Flag,"ignore",translate("Enable"))
o.rmempty=false
o.width="30px"
function o.cfgvalue(...)
local e=Flag.cfgvalue(...)
return e=="1"and"0"or"1"
end
function o.write(t,a,e)
Flag.write(t,a,e=="1"and"0"or"1")
end
o=s5:option(DummyValue,"interface",translate("Interface"))
o.template="cbi/network_netinfo"
o.width="10%"
o=s5:option(DummyValue,"suffix",translate("Suffix"))
o.width="60%"
function o.cfgvalue(t,e)
local t=m.uci:get_list("radvd",e,"suffix")
local e={}
for t in n.imatch(t)do
e[#e+1]=t
end
if#e==0 then
e[1]="?"
end
return table.concat(e,", ")
end
o=s5:option(DummyValue,"AdvDNSSLLifetime",translate("Lifetime"))
function o.cfgvalue(e,t)
local e=Value.cfgvalue(e,t)or"1200"
return translate(e)
end
return m
