local e=arg[1]
local a=require"luci.util"
m=Map("radvd",translatef("Radvd - Prefix"),
translate("Radvd is a router advertisement daemon for IPv6. "..
"It listens to router solicitations and sends router advertisements "..
"as described in RFC 4861."))
m.redirect=luci.dispatcher.build_url("admin/network/radvd")
if m.uci:get("radvd",e)~="prefix"then
luci.http.redirect(m.redirect)
return
end
s=m:section(NamedSection,e,"interface",translate("Prefix Configuration"))
s.addremove=false
s:tab("general",translate("General"))
s:tab("advanced",translate("Advanced"))
o=s:taboption("general",Flag,"ignore",translate("Enable"))
o.rmempty=false
function o.cfgvalue(...)
local e=Flag.cfgvalue(...)
return e=="1"and"0"or"1"
end
function o.write(t,e,a)
Flag.write(t,e,a=="1"and"0"or"1")
end
o=s:taboption("general",Value,"interface",translate("Interface"),
translate("Specifies the logical interface name this section belongs to"))
o.template="cbi/network_netlist"
o.nocreate=true
o.optional=false
function o.formvalue(...)
return Value.formvalue(...)or"-"
end
function o.validate(t,e)
if e=="-"then
return nil,translate("Interface required")
end
return e
end
function o.write(a,e,t)
m.uci:set("radvd",e,"ignore",0)
m.uci:set("radvd",e,"interface",t)
end
o=s:taboption("general",DynamicList,"prefix",translate("Prefixes"),
translate("Advertised IPv6 prefixes. If empty, the current interface prefix is used"))
o.optional=true
o.datatype="ip6addr"
o.placeholder=translate("default")
function o.cfgvalue(e,t)
local e={}
local t=m.uci:get_list("radvd",t,"prefix")
for t in a.imatch(t)do
e[#e+1]=t
end
return e
end
o=s:taboption("general",Flag,"AdvOnLink",translate("On-link determination"),
translate("Indicates that this prefix can be used for on-link determination (RFC4861)"))
o.rmempty=false
o.default="1"
o=s:taboption("general",Flag,"AdvAutonomous",translate("Autonomous"),
translate("Indicates that this prefix can be used for autonomous address configuration (RFC4862)"))
o.rmempty=false
o.default="1"
o=s:taboption("advanced",Flag,"AdvRouterAddr",translate("Advertise router address"),
translate("Indicates that the address of interface is sent instead of network prefix, as is required by Mobile IPv6"))
o=s:taboption("advanced",Value,"AdvValidLifetime",translate("Valid lifetime"),
translate("Advertises the length of time in seconds that the prefix is valid for the purpose of on-link determination."))
o.datatype='or(uinteger,"infinity")'
o.placeholder=86400
o=s:taboption("advanced",Value,"AdvPreferredLifetime",translate("Preferred lifetime"),
translate("Advertises the length of time in seconds that addresses generated from the prefix via stateless address autoconfiguration remain preferred."))
o.datatype='or(uinteger,"infinity")'
o.placeholder=14400
o=s:taboption("advanced",Value,"Base6to4Interface",translate("6to4 interface"),
translate("Specifies a logical interface name to derive a 6to4 prefix from. The interfaces public IPv4 address is combined with 2002::/3 and the value of the prefix option"))
o.template="cbi/network_netlist"
o.nocreate=true
o.unspecified=true
return m
