local e=arg[1]
local a=require"luci.util"
m=Map("radvd",translatef("Radvd - RDNSS"),
translate("Radvd is a router advertisement daemon for IPv6. "..
"It listens to router solicitations and sends router advertisements "..
"as described in RFC 4861."))
m.redirect=luci.dispatcher.build_url("admin/network/radvd")
if m.uci:get("radvd",e)~="rdnss"then
luci.http.redirect(m.redirect)
return
end
s=m:section(NamedSection,e,"interface",translate("RDNSS Configuration"))
s.addremove=false
o=s:option(Flag,"ignore",translate("Enable"))
o.rmempty=false
function o.cfgvalue(...)
local e=Flag.cfgvalue(...)
return e=="1"and"0"or"1"
end
function o.write(t,e,a)
Flag.write(t,e,a=="1"and"0"or"1")
end
o=s:option(Value,"interface",translate("Interface"),
translate("Specifies the logical interface name this section belongs to"))
o.template="cbi/network_netlist"
o.nocreate=true
o.optional=false
function o.formvalue(...)
return Value.formvalue(...)or"-"
end
function o.validate(t,e)
if e=="-"then
return nil,translate("Interface required")
end
return e
end
function o.write(a,e,t)
m.uci:set("radvd",e,"ignore",0)
m.uci:set("radvd",e,"interface",t)
end
o=s:option(DynamicList,"addr",translate("Addresses"),
translate("Advertised IPv6 RDNSS. If empty, the current IPv6 address of the interface is used"))
o.optional=false
o.rmempty=true
o.datatype="ip6addr"
o.placeholder=translate("default")
function o.cfgvalue(e,t)
local e={}
local t=m.uci:get_list("radvd",t,"addr")
for t in a.imatch(t)do
e[#e+1]=t
end
return e
end
o=s:option(Value,"AdvRDNSSLifetime",translate("Lifetime"),
translate("Specifies the maximum duration how long the RDNSS entries are used for name resolution."))
o.datatype='or(uinteger,"infinity")'
o.placeholder=1200
return m
